#include <xtl.h>
#include <stdio.h>
#include "kernel.h"

#define SYS_STRING "\\System??\\%s"
#define USR_STRING "\\??\\%s"

DWORD __declspec(naked) HvxSetState(DWORD mode)
{ 
	__asm {
		li      r0, 0x76
		sc
		blr
	}
}

HRESULT doMountPath(const char* szDrive, const char* szDevice, const char* sysStr)
{
	CHAR szDestinationDrive[MAX_PATH];
	sprintf_s(szDestinationDrive, MAX_PATH, sysStr, szDrive);
	STRING DeviceName = MAKE_STRING(szDevice);
	STRING LinkName = MAKE_STRING(szDestinationDrive);
	ObDeleteSymbolicLink(&LinkName);
	return (HRESULT)ObCreateSymbolicLink(&LinkName, &DeviceName);
}

HRESULT MountPath(const char* szDrive, const char* szDevice, BOOL both)
{
	HRESULT res;
	if(both)
	{
		res = doMountPath(szDrive, szDevice, SYS_STRING);
		res = doMountPath(szDrive, szDevice, USR_STRING);
	}
	else
	{
		if(KeGetCurrentProcessType() == SYSTEM_PROC)
			res = doMountPath(szDrive, szDevice, SYS_STRING);
		else
			res = doMountPath(szDrive, szDevice, USR_STRING);
	}
	return res;
}

DWORD resolveFunct(PCHAR modname, DWORD ord)
{
	DWORD ret=0, ptr2=0;
	HANDLE hand;
	ret = XexGetModuleHandle(modname, &hand); //xboxkrnl.exe xam.dll?
	if(ret == 0)
	{
		ret = XexGetProcedureAddress(hand, ord, &ptr2 );
		if(ptr2 != 0)
			return ptr2;
	}
	return 0; // function not found
}

BOOL fileExists(PCHAR path)
{
	HANDLE file = CreateFile(path, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(file == INVALID_HANDLE_VALUE)
		return 0;
	CloseHandle(file);
	return 1;
}

VOID patchInJump(PDWORD addr, DWORD dest, BOOL linked, PDWORD save)
{
	if(save != NULL)
	{
		int i;
		for(i = 0; i<4; i++)
		{
			save[i] = addr[i];
		}
	}
	if(dest & 0x8000) // If bit 16 is 1
		addr[0] = 0x3D600000 + (((dest >> 16) & 0xFFFF) + 1); // lis 	%r11, dest>>16 + 1
	else
		addr[0] = 0x3D600000 + ((dest >> 16) & 0xFFFF); // lis 	%r11, dest>>16

	addr[1] = 0x396B0000 + (dest & 0xFFFF); // addi	%r11, %r11, dest&0xFFFF
	addr[2] = 0x7D6903A6; // mtctr	%r11

	if(linked)
		addr[3] = 0x4E800421; // bctrl
	else
		addr[3] = 0x4E800420; // bctr
	__dcbst(0, addr);
	__sync();
}

VOID restoreJump(PDWORD addr, PDWORD save)
{
	if(save != NULL)
	{
		int i;
		for(i = 0; i<4; i++)
		{
			addr[i] = save[i];
		}
	}
}

DWORD HookOrd(DWORD ord, DWORD dstFun, PHV_IMAGE_EXPORT_TABLE expbase)
{
	DWORD modOffset = (expbase->ImageBaseAddress)<<16;
	DWORD origOffset = (expbase->ordOffset[ord-1])+modOffset;
	expbase->ordOffset[ord-1] = dstFun-modOffset;
	__dcbst(0, &expbase->ordOffset[ord-1]);
	__sync();
	return origOffset;
}
