#ifndef _UTILITY_H
#define _UTILITY_H

// change whether TLB memory protections are in effect
#define SET_PROT_OFF	2
#define SET_PROT_ON		3
DWORD HvxSetState(DWORD mode);

// resolve an ordinal to an address
DWORD resolveFunct(PCHAR modname, DWORD ord);

// mount a path to a drive name
HRESULT MountPath(const char* szDrive, const char* szDevice, BOOL both);

// returns true if the file exists
BOOL fileExists(PCHAR path);

// patches in a 4 instruction jump which uses R11/scratch reg and ctr to assemble
// addr = pointer to address being patched
// dest = address of the new destination
// linked = (true = ctr branch with link used) (false = ctr branch, link register unaffected)
// save = pointer to stow the 4 32bit instructions that were replaced
VOID patchInJump(PDWORD addr, DWORD dest, BOOL linked, PDWORD save);

// puts back cached bytes from patchInJump
// addr = pointer to address being patched
// save = pointer to restore the 4 32bit instructions that were replaced
VOID restoreJump(PDWORD addr, PDWORD save);

// hook export ordinals of a module
// ord = ordinal number
// dstFun = address to change ordinal link address to
// expbase = base address of HV export table (EAT - export address table) signature of module being patched
//			signature bytes of hv export table is "48 00 00 00 00 48 56 45 48 00 00 00 00 00 45 DC"
// ** note that this type of hook ONLY works on things that haven't been linked by the time the patch is made
DWORD HookOrd(DWORD ord, DWORD dstFun, PHV_IMAGE_EXPORT_TABLE expbase);


#endif // _UTILITY_H
