#include <xtl.h>
#include <stdio.h>
#include "AtgUtil.h"
#include "AtgInput.h"
#include "kernel.h"
#include "util.h"

HRESULT Mount(PCHAR szDrive, PCHAR szDevice)
{
	CHAR szDestinationDrive[MAX_PATH];
	sprintf_s(szDestinationDrive, MAX_PATH, "\\??\\%s", szDrive);
	STRING DeviceName = MAKE_STRING(szDevice);
	STRING LinkName = MAKE_STRING(szDestinationDrive);
	ObDeleteSymbolicLink(&LinkName);
	return (HRESULT)ObCreateSymbolicLink(&LinkName, &DeviceName);
}

BOOL fileExists(PCHAR path)
{
	HANDLE file = CreateFile(path, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(file == INVALID_HANDLE_VALUE)
		return 0;
	CloseHandle(file);
	return 1;
}

BOOL getConfirm(VOID)
{
	BOOL ret = FALSE;
	BOOL wait = TRUE;
	while(wait)
	{
		ATG::Input::GetMergedInput();

		if( ATG::Input::m_DefaultGamepad.wPressedButtons & XINPUT_GAMEPAD_A )
		{
			ret = TRUE;
			wait = FALSE;
		}
		else if( ATG::Input::m_DefaultGamepad.wPressedButtons & XINPUT_GAMEPAD_B )
		{
			wait = FALSE;
		}
	}
	return ret;
}

DWORD readFileToBuf(char* fileName, BYTE* buf, DWORD maxLen)
{
	HANDLE file;
	DWORD dwRead = 0;
	file = CreateFileA(fileName, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(file != INVALID_HANDLE_VALUE)
	{
		ZeroMemory(buf, maxLen);
		ReadFile(file, buf, maxLen, &dwRead, NULL);
		CloseHandle(file);
	}
	return dwRead;
}

// returns true if the buffers are equal
BOOL byteBufCmp(BYTE* buf1, BYTE* buf2, DWORD len)
{
	DWORD i;
	for(i = 0; i < len; i++)
	{
		if(buf1[i] != buf2[i])
			return FALSE;
	}
	return TRUE;
}
