//--------------------------------------------------------------------------------------
//	start xell from a xex, required documented hv patch below to work
//--------------------------------------------------------------------------------------
#include <xtl.h>
#include <stdio.h>
#include "kernel.h"

#define NAND_XELL_OFFSET 0x95060
#ifdef __cplusplus
extern "C" {
#endif

	HRESULT __stdcall ObCreateSymbolicLink( STRING*, STRING*);
	HRESULT __stdcall ObDeleteSymbolicLink( STRING* );

	NTSYSAPI
	DWORD
	NTAPI
	XexGetModuleHandle(
		IN		PSZ moduleName,
		IN OUT	PHANDLE hand
		); 

	// ie XexGetProcedureAddress(hand ,0x50, &addr) returns 0 on success
	NTSYSAPI
	DWORD
	NTAPI
	XexGetProcedureAddress(
		IN		HANDLE hand,
		IN		DWORD dwOrdinal,
		IN		PVOID Address
		);

	NTSYSAPI
	PVOID
	NTAPI
	MmGetPhysicalAddress(
		IN		PVOID Address
		);

	NTSYSAPI
	void
	NTAPI
	DbgPrint(
		const char* s,
		...
		);

#ifdef __cplusplus
}
#endif

HRESULT Mount(PCHAR szDrive, PCHAR szDevice)
{
	CHAR szDestinationDrive[MAX_PATH];
	sprintf_s(szDestinationDrive, MAX_PATH, "\\??\\%s", szDrive);
	STRING DeviceName = MAKE_STRING(szDevice);
	STRING LinkName = MAKE_STRING(szDestinationDrive);
	ObDeleteSymbolicLink(&LinkName);
	return (HRESULT)ObCreateSymbolicLink(&LinkName, &DeviceName);
}

// one more modification to our favorite syscall... should be possible to use this
// to exec arbitrary code in hv state, registers r7-r10 will be forwarded
// just make sure to preserve the link register and blr when done
// (r3 = 4, r4 = dest/entry, r5 = src, r6 = lenInU32)
DWORD __declspec(naked) HvxSetState(DWORD mode, UINT64 dest, UINT64 src, UINT64 linInU32)
{ 
	__asm {
		li      r0, 0x76
		sc
		blr
	}
}
/* the code that is actually called here...
		cmplwi  cr6, %r3, 4			# xell loader
		beq		cr6, bin_launch
	...
bin_launch:
		mflr	%r12  # stow on stack
		std		%r12, -0x8(%sp)
		stdu    %sp, -0x10(%sp)
		mtlr 	%r4
		mtctr   %r6
		# Copy src = %r5, dst = %r6
lcopyloop:
		lwz     %r3, 0(%r5)
		stw     %r3, 0(%r4)
		dcbst   %r0, %r4	
		icbi	%r0, %r4
		sync	0
		isync
		addi    %r4, %r4, 4
		addi    %r5, %r5, 4
		bdnz    lcopyloop
		blr
		addi	%sp, %sp, 0x10
		ld		%r12, -0x8(%sp)
		mtlr	%r12	#loaded from stack
		blr	
*/

char* devices[] = {
	"\\Device\\Mass0\\",
	"\\Device\\Mass1\\",
	"\\Device\\Mass2\\",
	"\\Device\\Harddisk0\\Partition1\\",
	"\\Device\\Cdrom0\\",
};
char fileName[] = "xl:\\xell.bin";

BYTE xelldata[0x40000];
DWORD xellsize;

void startXell(BOOL useNand)
{
//	UINT64 dest = 0x8000000013000000ULL; // xell-ll
//	UINT64 dest = 0x800000001c000000ULL; // xell-1f
	UINT64 dest = 0x800000001c040000ULL; // xell-2f
	UINT64 src = 0x8000000000000000ULL;
	UINT64 len = 0;

	if(useNand)
	{
		src = 0x80000200C8095060ULL;
		len = len+0x10000;
		DbgPrint("syscall - starting xell nand\n");
		HvxSetState(4, dest, src, len);
	}
	else
	{
		PBYTE xell_buf = (PBYTE)XPhysicalAlloc(0x40000, MAXULONG_PTR, 0, MEM_LARGE_PAGES|PAGE_READWRITE|PAGE_NOCACHE);
		ZeroMemory(xell_buf, 0x40000);
		memcpy(xell_buf, xelldata, xellsize);
		src = src+((DWORD)MmGetPhysicalAddress(xell_buf));
		len = 0+((xellsize/4)& 0xFFFFFFFF);
		DbgPrint("syscall - starting xell file\n");
		HvxSetState(4, dest, src, len);
	}
}

DWORD readFile(const char* path)
{
	DWORD read = 0;
	HANDLE file = CreateFile(path, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(file == INVALID_HANDLE_VALUE)
		return read;
	ReadFile(file, xelldata, 0x40000, &read, NULL);
	CloseHandle(file);
	return read;
}

VOID __cdecl main()
{
	int i;
	// check for xell.bin on mass0, mass1, mass2, hdd then CD; if found load it
	for(i = 0; i < 5; i++)
	{
		Mount("xl:", devices[i]);
		xellsize = readFile("xl:\\xell.bin");
		if(xellsize != 0)
			startXell(FALSE);
	}

	// if not check in the launched xex path
	xellsize = readFile("GAME:\\xell.bin");
	if(xellsize != 0)
		startXell(FALSE);

	// if not use NAND
	startXell(TRUE);

	// all else fails (it'll crash first unless the patches are missing) just drop back to dash
	XLaunchNewImage(XLAUNCH_KEYWORD_DEFAULT_APP, 0);
}
